package data;
import java.lang.*;

//--------------------------------------------------------------------//
/**
 * v~eBu^l}bv̒ۃX[p[NX
 */
public abstract class AbstractNumberMap implements NumberMap,Cloneable{

/** eʂ̃ftHgl */
  protected static final int DEFAULT_INITIAL_CAPACITY=16;

/** eʂ̍ől */
  protected static final int MAXIMUM_CAPACITY=1<<30;

/** ׌W̃ftHgl */
  protected static final float DEFAULT_LOAD_FACTOR=0.75f;

/** }bvɊ܂܂Gg[̐ */
  protected int size;

  protected AbstractNumberMap(){
    size=0;
  }

//--------------------------------------------------------------------//
/**
 * }bvɊ܂܂L[ƒl̑g̐Ԃ
 * @return }bvɊ܂܂L[ƒl̑g̐
 */
  public int size(){
    return entries().length;
  }

//--------------------------------------------------------------------//
/**
 * }bvL[ƒl̑g܂܂Ȃǂʂ
 * @return }bvL[ƒl̑g܂܂Ȃꍇ true
 */
  public boolean isEmpty(){
    return (size()==0);
  }

//--------------------------------------------------------------------//
/**
 * }bvw肳ꂽL[܂ނǂʂ
 * @param key }bv܂ނǂʂL[
 * @return }bvw肳ꂽL[܂ޏꍇ true
 */
  public boolean containsKey(double key){
    double keys[]=keys();
    for(int i=0;i<keys.length;i++){
      if(key==keys[i]) return true;
    }
    return false;
  }

//--------------------------------------------------------------------//
/**
 * }bvw肳ꂽl܂ނǂʂ
 * @param value }bv܂ނǂʂl
 * @return }bvw肳ꂽl܂ޏꍇ true
 */
  public boolean containsValue(double value){
    double values[]=values();
    for(int i=0;i<values.length;i++){
      if(value==values[i]) return true;
    }
    return false;
  }

//--------------------------------------------------------------------//
/**
 * lԂ
 * @param key loL[
 * @return w肳ꂽL[ɑΉl
 */
  public double get(double key){
    Entry entries[]=entries();
    for(int i=0;i<entries.length;i++){
      if(key==entries[i].getKey()) return entries[i].getValue();
    }
    return Double.NaN;
  }

//--------------------------------------------------------------------//
/**
 * }bsOǉ
 * @param map ǉ}bv
 */
  public void putAll(NumberMap map){
    Entry entries[]=map.entries();
    for(int i=0;i<entries.length;i++){
      put(entries[i].getKey(),entries[i].getValue());
    }
  }

//--------------------------------------------------------------------//
/**
 * }bvɊ܂܂SẴL[Ԃ
 * @return }bvɊ܂܂SẴL[i[z
 */
  public double[] keys(){
    Entry entries[]=entries();
    double keys[]=new double[entries.length];
    for(int i=0;i<entries.length;i++) keys[i]=entries[i].getKey();
    return keys;
  }

//--------------------------------------------------------------------//
/**
 * }bvɊ܂܂SĂ̒lԂ
 * @return }bvɊ܂܂SĂ̒li[z
 */
  public double[] values(){
    Entry entries[]=entries();
    double values[]=new double[entries.length];
    for(int i=0;i<entries.length;i++) values[i]=entries[i].getValue();
    return values;
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃Rs[Ԃ
 * @return ̃CX^X̕
 */
  public Object clone(){
    try{
      return super.clone();
    }
    catch(CloneNotSupportedException ex){
      throw new InternalError();
    }
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃nbVR[hlԂ
 * @return IuWFNg̃nbVR[hl
 */
  public int hashCode(){
    Entry entries[]=entries();
    int bit=1;
    for(int i=0;i<entries.length;i++){
      bit=31*bit+entries[i].hashCode();
    }
    return bit;
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̓
 * @param obj rΏۂ̃IuWFNg
 * @return rΏۂ̃IuWFNg <code>NumberMap</code>
 *         ̃CX^XœGg[ꍇ true
 */
  public boolean equals(Object obj){
    if(obj==this) return true;
    if(obj instanceof NumberMap){
      NumberMap map=(NumberMap)obj;
      Entry entries1[]=entries();
      Entry entries2[]=map.entries();
      if(entries1.length!=entries2.length) return false;
      for(int i=0;i<entries1.length;i++){
      	if(!entries1[i].equals(entries2[i])) return false;
      }
      return true;
    }
    return false;
  }

//--------------------------------------------------------------------//
/**
 * f[^Ԃ
 * @return ̃IuWFNg̕\
 */
  public String toString(){
    Entry entries[]=entries();
    if(entries.length==0) return "";
    StringBuffer sb=new StringBuffer();
    for(int i=0;i<entries.length-1;i++){
      sb.append(entries[i]);
      sb.append('\t');
    }
    sb.append(entries[entries.length-1]);
    return sb.toString();
  }
}
