package gui.table;
import java.awt.Component;
import java.lang.*;
import java.util.Set;
import javax.swing.JTable;
import javax.swing.table.DefaultTableCellRenderer;

//--------------------------------------------------------------------//
/**
 * We[ũZ`NX
 */
public class BasicTableCellRenderer extends DefaultTableCellRenderer{

/** ZʒũZbg */
  private Set cellPositionSet;

/**
 * Z̕`IuWFNg\z
 */
  public BasicTableCellRenderer(Set cellPositionSet){
    super();
    this.cellPositionSet=cellPositionSet;
  }

//--------------------------------------------------------------------//
/**
 * Z̕`ɎgpR|[lgԂ
 * @param table `悷邽߂Ƀ_O߂ JTable
 * @param value Z̒l
 * @param isSelected Z̑I
 * @param hasFocus Z̃tH[JX
 * @param row Z̍s
 * @param column Z̗
 * @return Z̕`ɎgpR|[lg
 */
  public Component getTableCellRendererComponent
    (JTable table,Object value,boolean isSelected,boolean hasFocus
    ,int row,int column){
    if(isExtracted(row,column)){
      return getExtractedTableCellRendererComponent
      	       (table,value,isSelected,hasFocus,row,column);
    }
    else{
      setBackground(table.getBackground());
      return super.getTableCellRendererComponent
      	       (table,value,isSelected,hasFocus,row,column);
    }
  }

//--------------------------------------------------------------------//
/**
 * oꂽZ̕`ɎgpR|[lgԂ
 * @param table `悷邽߂Ƀ_O߂ JTable
 * @param value Z̒l
 * @param isSelected Z̑I
 * @param hasFocus Z̃tH[JX
 * @param row Z̍s
 * @param column Z̗
 * @return Z̕`ɎgpR|[lg
 */
  protected Component getExtractedTableCellRendererComponent
    (JTable table,Object value,boolean isSelected,boolean hasFocus
    ,int row,int column){
    setBackground(table.getTableHeader().getBackground());
    return super.getTableCellRendererComponent
      	     (table,value,isSelected,hasFocus,row,column);
  }

//--------------------------------------------------------------------//
/**
 * Zo邩ǂԂ
 * @param row Z̍s
 * @param column Z̗
 * @return Zoꍇ true
 */
  protected boolean isExtracted(int row,int column){
    return cellPositionSet.contains(new CellPosition(row,column));
  }
}
