package laf;
import java.lang.*;

//--------------------------------------------------------------------//
/**
 * `p[^̃L[
 */
public class DrawParameterKey implements Cloneable{

/** UĨL[ */
  public static final DrawParameterKey
    DECORATED=new DrawParameterKey("decorated");

/** bNAhtB[NX̃L[ */
  public static final DrawParameterKey
    LAF_CLASS=new DrawParameterKey("class");

/** ^e[}̃L[ */
  public static final DrawParameterKey
    THEME_NAME=new DrawParameterKey("metaltheme","name");

/** ^e[}\F̃L[i[z */
  public static DrawParameterKey
    THEME_COLORS[]=new DrawParameterKey[VariableMetalTheme.COLORS];

/** tHĝ̃L[ */
  public static final DrawParameterKey
    FONT_NAME=new DrawParameterKey("font","name");

/** tHgX^C̃L[ */
  public static final DrawParameterKey
    FONT_STYLE=new DrawParameterKey("font","style");

/** tHgTCỸL[ */
  public static final DrawParameterKey
    FONT_SIZE=new DrawParameterKey("font","size");

/** wiF̃L[ */
  public static final DrawParameterKey
    BG_COLOR=new DrawParameterKey("color","bgcolor");

/** OiF̃L[ */
  public static final DrawParameterKey
    FG_COLOR=new DrawParameterKey("color","fgcolor");

/** ⏕\F̃L[ */
  public static final DrawParameterKey
    SUB_COLOR=new DrawParameterKey("color","subcolor");

/** ̃L[ */
  public static final DrawParameterKey
    LANGUAGE=new DrawParameterKey("language");

/** L[̖ */
  private String name;

/** L[̑l */
  private String attribute;

/**
 * `p[^̃L[\z
 * @param name L[̖
 */
  public DrawParameterKey(String name){
    this(name,null);
  }

/**
 * `p[^̃L[\z
 * @param name L[̖
 * @param attribute L[̑l
 */
  public DrawParameterKey(String name,String attribute){
    this.name=name;
    if(attribute==null) this.attribute="";
    else                this.attribute=attribute;
  }

//--------------------------------------------------------------------//
/**
 * L[̖̂Ԃ
 * @return L[̖
 */
  public String getName(){
    return name;
  }

//--------------------------------------------------------------------//
/**
 * L[̑lԂ
 * @return L[̑l
 */
  public String getAttribute(){
    return attribute;
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃Rs[Ԃ
 * @return ̃CX^X̕
 */
  public Object clone(){
    try{
      return super.clone();
    }
    catch(CloneNotSupportedException ex){
      throw new InternalError();
    }
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃nbVR[hlԂ
 * @return IuWFNg̃nbVR[hl
 */
  public int hashCode(){
    return 31*name.hashCode()+attribute.hashCode();
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̓
 * @param obj rΏۂ̃IuWFNg
 * @return rΏۂ̃IuWFNg <code>DrawParameterKey</code>
 *         ̃CX^Xœlꍇ true
 */
  public boolean equals(Object obj){
    if(obj instanceof DrawParameterKey){
      DrawParameterKey key=(DrawParameterKey)obj;
      return (name.equals(key.getName())
      	   && attribute.equals(key.getAttribute()));
    }
    return false;
  }

//--------------------------------------------------------------------//
/**
 * f[^Ԃ
 * @return ̃IuWFNg̕\
 */
  public String toString(){
    if(attribute.equals("")) return name;
    else                     return name+"-"+attribute;
  }
}
