package resourcemanager;
import java.awt.Image;
import java.lang.*;
import java.net.URL;
import javax.swing.Icon;
import javax.swing.ImageIcon;

//--------------------------------------------------------------------//
/**
 * ACRǗNX
 */
public class IconManager extends ResourceManager{

/** ACR摜f[^i[fBNg */
  protected static String DIRECTORY="/resource/Icon/";

/** ACRǗIuWFNg */
  protected static IconManager MANAGER=new IconManager();

/**
 * ACRǗIuWFNg̍\z
 */
  protected IconManager(){
    super();
  }

//--------------------------------------------------------------------//
/**
 * ACRԂ
 * @param name C[Wt@C
 * @return ACR
 */
  public Icon getIcon(String name){
    URL url=getURL(name);
    if(url==null) return null;
    else          return new ImageIcon(url);
  }

//--------------------------------------------------------------------//
/**
 * ACRԂ
 * @param name C[Wt@C
 * @return ACR
 */
  public static Icon get(String name){
    return MANAGER.getIcon(DIRECTORY+name);
  }

//--------------------------------------------------------------------//
/**
 * ACR̃C[WԂ
 * @param name C[Wt@C
 * @return ACR̃C[W
 */
  public Image getIconImage(String name){
    URL url=getURL(name);
    if(url==null){
      return null;
    }
    else{
      ImageIcon icon=new ImageIcon(url);
      return icon.getImage();
    }
  }

//--------------------------------------------------------------------//
/**
 * ACR̃C[WԂ
 * @param name C[Wt@C
 * @return ACR̃C[W
 */
  public static Image getImage(String name){
    return MANAGER.getIconImage(DIRECTORY+name);
  }
}
