package laf;
import java.io.IOException;
import java.lang.*;
import java.net.URL;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;
import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;
import resourcemanager.LAFManager;

//--------------------------------------------------------------------//
/**
 * bNAhtB[ XML `f[^̓NX
 */
public class XMLLookAndFeelReader{

/**
 * bNAhtB[ XML `f[^̓IuWFNg\z
 */
  public XMLLookAndFeelReader(){
  }

//--------------------------------------------------------------------//
/**
 * bNAhtB[f[^ǂݍ
 */
  public static void read(){
    try{
      XMLLookAndFeelReader reader=new XMLLookAndFeelReader();
      reader.read(LAFManager.getXML());
      CommandMap.read(DrawParameter.getLanguage());
      WordMap.read(DrawParameter.getLanguage());
    }
    catch(Exception ex){
      System.out.println(ex);
    }
  }

//--------------------------------------------------------------------//
/**
 * bNAhtB[f[^ǂݍ
 * @param url bNAhtB[f[^ URL
 * @throws ParserConfigurationException
 *         vꂽ\𖞂 <code>SAXParser</code>
 *         𐶐łȂƂ
 * @throws SAXException \̓G[Ƃ
 * @throws IOException o̓G[Ƃ
 */
  public void read(URL url)
    throws ParserConfigurationException,SAXException,IOException{

    if(url==null) return;
    SAXParserFactory factory=SAXParserFactory.newInstance();
    SAXParser parser=factory.newSAXParser();
    parser.parse(url.openStream(),new DataReadHandler());
  }

//--------------------------------------------------------------------//
/**
 * f[^ǂݍ SAX Cxgnh-
 */
  protected class DataReadHandler extends DefaultHandler{

/** ^O */
    protected String tag;

/** ^O */
    protected String attribute;

    public DataReadHandler(){
      super();
      tag=null;
      attribute=null;
    }

//--------------------------------------------------------------------//
/**
 * vf̐擪ǂݍ
 * @param uri O URI
 * @param localName ړ܂܂Ȃ[J
 * @param qName ړC
 * @param attributes vfɕtꂽ
 * @throws SAXException \̓G[Ƃ
 */
    public void startElement(String uri,String localName,String qName,
      	      	      	     Attributes attributes)
      throws SAXException{

      tag=qName;
      attribute=null;
      if(attributes!=null){
      	for(int i=0;i<attributes.getLength();i++){
      	  if(attributes.getQName(i).toLowerCase().equals("parameter")){
      	    attribute=attributes.getValue(i);
      	  }
      	}
      }
    }

//--------------------------------------------------------------------//
/**
 * f[^ǂݍ
 * @param ch f[^
 * @param start z̊Jnʒu
 * @param length z񂩂gp镶
 * @throws SAXException \̓G[Ƃ
 */
    public void characters(char[] ch,int start,int length)
      throws SAXException{

      if(tag==null) return;
      String value=new String(ch,start,length).trim();
      if(!value.equals("")){
      	DrawParameter.putString(new DrawParameterKey(tag,attribute),
      	      	      	      	value);
      }
    }

//--------------------------------------------------------------------//
/**
 * ̏Iʒm󂯎
 */
    public void endDocument() throws SAXException{
      DrawParameter.set();
    }
  }
}
