package worldmap.io;
import java.awt.Component;
import java.io.File;
import java.lang.*;
import javax.imageio.ImageIO;
import javax.swing.filechooser.FileFilter;
import fileio.FileSaveAction;
import fileio.WritableImageFileFilter;
import worldmap.RegionList;
import worldmap.WorldMapFrame;
import worldmap.WorldMapModel;

//--------------------------------------------------------------------//
/**
 * t@CۑANV
 */
public class DataSaveAction extends FileSaveAction{

/** n}\t[ */
  private WorldMapFrame frame;

/**
 * ANVIuWFNg\z
 * @param frame n}\t[
 */
  public DataSaveAction(WorldMapFrame frame){
    super();
    this.frame=frame;
  }

//--------------------------------------------------------------------//
/**
 * [UI\ȃt@CtB^i[zԂ
 * @return [UI\ȃt@CtB^
 */
  protected FileFilter[] getFileFilters(){
    FileFilter filters[]={new WritableImageFileFilter(),
      	      	      	  new MapDataFileFilter()};
    return filters;
  }

//--------------------------------------------------------------------//
/**
 * _CAȌL҂Ԃ
 * @return _CAOL Component
 */
  protected Component getDialogOwner(){
    return frame;
  }

//--------------------------------------------------------------------//
/**
 * t@CɃf[^ۑ
 * @param file ۑt@C
 * @throws Exception 炩̗RŃt@CȂƂ
 */
  protected void save(File file) throws Exception{
    if(file.getName().toLowerCase().endsWith(".png")){
      ImageIO.write(frame.getPanel().getImage(),"png",file);
    }
    else{
      writeFile(file,frame.getRegionList(),frame.getModel());
    }
  }

//--------------------------------------------------------------------//
/**
 * t@CɃf[^ۑ
 * @param fileName t@C
 * @param list }bv̈惊Xg
 * @param map f[^oQ}bvf[^f
 * @throws Exception 炩̗RŃt@CȂƂ
 */
  public static void writeFile(String fileName,RegionList list,
      	      	      	       WorldMapModel map)
    throws Exception{

    writeFile(new File(fileName),list,map);
  }

//--------------------------------------------------------------------//
/**
 * t@CɃf[^ۑ
 * @param file t@C
 * @param list }bv̈惊Xg
 * @param map f[^oQ}bvf[^f
 * @throws Exception 炩̗RŃt@CȂƂ
 */
  public static void writeFile(File file,RegionList list,
      	      	      	       WorldMapModel map)
    throws Exception{

    WorldMapIO mapIO=new WorldMapIO(list,map);
    mapIO.write(file);
  }
}
